#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <math.h>
#include <errno.h>
#include "toolkit.h"
#include "tine.h"
#include "cdi.h"
#include "tinecdi.h"
#include "CdiJni.h"

/* incoming java bytes are not in intel order: have to pretend we're on a big-endian machine */
#undef ISWAP
#undef _ISWAP
#undef _LSWAP
#undef _DSWAP

#define ISWAP(w) ((((w)&0xff00)>>8)|(((w)&0xff)<<8))
#define _ISWAP(w) {\
  tmp = ((BYTE *)&w)[0]; ((BYTE *)&w)[0] = ((BYTE *)&w)[1]; ((BYTE *)&w)[1] = tmp;\
}
#define _LSWAP(w) {\
  tmp = ISWAP(((short *)&w)[0]); ((short *)&w)[0] = ISWAP(((short *)&w)[1]); ((short *)&w)[1] = tmp;\
}
#define _DSWAP(w) {\
  tmp = ISWAP(((short *)&w)[0]); ((short *)&w)[0] = ISWAP(((short *)&w)[3]); ((short *)&w)[3] = tmp;\
	tmp = ISWAP(((short *)&w)[1]); ((short *)&w)[1] = ISWAP(((short *)&w)[2]); ((short *)&w)[2] = tmp;\
}

int cdiSwapBytes(char *dat,int size,int fmt)
{
  register int i,tmp;

  switch(fmt)
  {
    case CF_NULL: 
      return 0;
    case CF_TEXT:
    case CF_BYTE:
    case CF_STRING8:
    case CF_STRING16:
    case CF_STRING32:
    case CF_STRING48:
    case CF_STRUCT:
      return 0;
    case CF_SHORT:
      for (i=0; i<size; i++) _ISWAP(((short *)dat)[i]);
	    return 0;
    case CF_BOOLEAN:
    case CF_LONG:
    case CF_FLOAT:
      for (i=0; i<size*4; i+=4) _LSWAP(dat[i]);
      return 0;
    case CF_DOUBLE:
      for (i=0; i<size*8; i+=8) _DSWAP(dat[i]);
      return 0;
    case CF_DBLDBL:
      for (i=0; i<size*16; i+=16) {_DSWAP(dat[i]); _DSWAP(dat[i+8]);}
      return 0;
    case CF_FLTINT:
    case CF_INTINT:
      for (i=0; i<size*8; i+=8) {_LSWAP(dat[i]); _LSWAP(dat[i+4]);}
      return 0;
    case CF_NAME16DBLDBL:
      for (i=0; i<size*32; i+=32) {_DSWAP(dat[16+i]); _DSWAP(dat[16+i+8]);}
      return 0;
    case CF_NAME32DBLDBL:
      for (i=0; i<size*48; i+=48) {_DSWAP(dat[32+i]); _DSWAP(dat[32+i+8]);}
      return 0;
    case CF_NAME64DBLDBL:
      for (i=0; i<size*80; i+=80) {_DSWAP(dat[64+i]); _DSWAP(dat[64+i+8]);}
      return 0;
    case CF_NAME16FI:
    case CF_NAME16II:
      for (i=0; i<size*24; i+=24) {_LSWAP(dat[i+16]); _LSWAP(dat[i+20]);}
      return 0;
    default:
      cdilog("JNI: cannot swap format %d",fmt);
      break;
  }
  return illegal_format;
}

