#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <math.h>
#include <errno.h>
#include "toolkit.h"
#include "tine.h"
#include "cdi.h"
#include "tinecdi.h"
#include "cdiWinRS232Lib.h"

int cdiInitWinComm(void)
{
  int cc = 0;

  if ((cc=cdiRegisterBusFilter("WINCOMM",filterRS232Bus)) != 0 ) goto err;
  if ((cc=cdiRegisterBusInitialization("WINCOMM",initRS232ForCDI)) != 0 ) goto err;
  if ((cc=cdiRegisterBusHandler("WINCOMM",execRS232)) != 0 ) goto err;
  if ((cc=cdiRegisterBusCleanup("WINCOMM",closeSerialPort)) != 0 ) goto err;

err:
  if (cc)
  {
    cdilog("%s : failure in bus registration WINCOMM",erlst[cc]);
  }
  return cc;
}

BOOL WINAPI DllMain(HINSTANCE hInstDll,DWORD fdwReason,LPVOID lpvReserved)
{
  int i;
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:  // DLL being loaded
      cdiInitWinComm();
      break;
    case DLL_THREAD_ATTACH:
      break;
    case DLL_THREAD_DETACH:
      break;
    case DLL_PROCESS_DETACH:  // DLL being unloaded
      for (i=1; i<=N_SERIAL_LINES; i++) closeSerialPort(i);
      break;
  }
  return (TRUE);
}
