#ifndef CDIRS232_H_
#define CDIRS232_H_

__declspec(dllexport) void execRS232(CdiRequestInfoBlk *pReq);
__declspec(dllexport) int filterRS232Bus(int *parameter, int accessFlag);
__declspec(dllexport) int initRS232ForCDI(int busLine, int cdiLine, int numberDevices, char *parameterList);
__declspec(dllexport) int closeSerialPort(int channelNumber);

#define N_SERIAL_LINES	4 	// com1 to com4

#define STRING_LENGTH	255
#define dwInQueue     1200
#define dwOutQueue    1200

/* open serial parameter index */
enum openSerialParamIndex
{
  paramBaudrate, /* e.g 9600 */
  param8bits, /* flag 1 or 0... */
  param2StopBits,
  paramParity,
  paramOddParity,
  paramFlowControl,
  paramCanonicalInput
};

typedef struct {
  int inputBaud, defBaud;
} BAUD_STRUCT;

#define REALLY_HAVE_RS232
#ifdef REALLY_HAVE_RS232
typedef struct {
  HANDLE serFd;		// serial File descripter
	int  channel,		// serial port channel, start from 0,1,2,3...
	  cdiLine,		// cdi Line index for getString then callback
	  baudRate,		// baudRate
	  canonicalMode,
	  usOneChar;	// time in us for one Char transmission
  DCB dcbCopy;	// stored DCB
  COMMTIMEOUTS commtmoutsCopy;
  OVERLAPPED overlap[2];  // read and write

  char	buf[STRING_LENGTH + 1];	// input string
  
  HANDLE	tIdMaster;		// receive task variables
  int ret, length, wrtRet;
  unsigned int iOut;

  void (*receiveString)(int cdiLine, char *string, unsigned int length);
} SER_STRUCT;

extern SER_STRUCT serInfo[N_SERIAL_LINES];

extern BAUD_STRUCT baudRate[];
extern int numBaudRate;

#endif

#endif /* CDIRS232_H_ */
