#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <math.h>
#include <errno.h>
#include "toolkit.h"
#include "tine.h"
#include "cdi.h"
#include "tinecdi.h"

#ifdef CDICLBRFCN_EXPORTS
# define CDICLBRFCN_EXPORT __declspec(dllexport)
#else
# define CDICLBRFCN_EXPORT 
#endif

CDICLBRFCN_EXPORT double bit12sgn(double v)
{
  short w = (short)v;
  short sgn = sgn = (w & 0x0800) == 0 ? 1 : -1;
  w &= 0x07ff;
  w *= sgn;
  return (double)w;
}
CDICLBRFCN_EXPORT double nib2exp(double v)
{
  short w = (short)v;
  return (double)((w&0xfff) * pow(10,-((short)(w>>12))));
}
CDICLBRFCN_EXPORT double bit12Recv(double value)
{
	short current = (short) value;
	current &= 0x07ff; // only get 11 bit
	current -= 2047;
	return (double) current;
}
CDICLBRFCN_EXPORT double bit12Send(double value)
{
	short current = (short) value;
	current += 2047;
	return (double) current;
}

void cdiRegisterFunctions(void)
{
  cdi_RegisterCalibrationFunction("bit12sgn",bit12sgn);
  cdi_RegisterCalibrationFunction("nib2exp",nib2exp);
  cdi_RegisterCalibrationFunction("bit12Recv",bit12Recv);
  cdi_RegisterCalibrationFunction("bit12Send",bit12Send);
}

BOOL WINAPI DllMain(HINSTANCE hInstDll,DWORD fdwReason,LPVOID lpvReserved)
{
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:  // DLL being loaded
      cdiRegisterFunctions();
      break;
    case DLL_THREAD_ATTACH:
      break;
    case DLL_THREAD_DETACH:
      break;
    case DLL_PROCESS_DETACH:  // DLL being unloaded
      break;
  }
  return (TRUE);
}
