/*
 * Created on Feb 28, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.simple.cdi;

import de.desy.tine.dataUtils.*;
import de.desy.tine.definitions.*;
import de.desy.tine.server.devices.TDevice;
import de.desy.tine.server.equipment.TEquipmentModule;
import de.desy.tine.server.properties.TPropertyHandler;

public class SimpleEquipmentModule extends TEquipmentModule
{
  TDevice[] deviceList = new TDevice[10];
  float amplitude = 300;
  float[] mySineData = new float[1024];
  float[] myTemperatureData = new float[100];
  public SimpleEquipmentModule()
  {
    super("WKSEQM");
    registerDevices(10);
    getExportInformationFromFile("WKSEQM");
    
    attachPropertyHandler("Sine",new TPropertyHandler()
      {
        protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
        {
          for (int i = 0; i < 1024; i++)
            mySineData[i] = (float)(25.0 * Math.random()) + amplitude * (float)Math.sin(6.2832 * ((double) i / 1024.0));
          return dout.putData(mySineData);
        }
      });    
    attachPropertyHandler("Temperature",new TPropertyHandler()
        {
          protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
          {
            for (int i = 0; i < 100; i++)
              myTemperatureData[i] = 20 + (float)(5.0 * Math.random());
            return dout.putData(myTemperatureData);
          }
        });    
    attachPropertyHandler("Amplitude",new TPropertyHandler()
        {
          protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess)
          {
            int compCode = 0;
            if (devAccess.isWrite())
            { // maybe put the following lines in a 'setAmplitude() method ?'
              float[] setting = new float[1];
              if ((compCode=din.getData(setting)) != 0) return compCode;
              if (setting[0] < 1 || setting[0] > 500) return TErrorList.out_of_range;
              amplitude = setting[0];
              int nr = getDeviceList().getDeviceNumber(devName);
              // assume for the 'test' moment that a change here need to go to
              // the corresponding cdi device nr 
              // (can also be set via the <fecname>.CDI server's "SEND" property
              HdwIo.setValue("#"+nr,(int)amplitude);
            }
            return dout.putData(amplitude);
          }
        });    
  }
}
